package org.okiproject.okifuncapi.utility;



/**
<p>
   Copyright (c) 2001 Massachusetts Institute of Technology
<p>
   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:
<p>
   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.
<p>
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.
<p>
$Source: /cvs/oki/org/okiproject/okifuncapi/utility/UtilityFactory.java,v $
@version@ $Revision: 1.2 $
$Date: 2002/02/08 14:25:42 $
*/
public class UtilityFactory
implements java.io.Serializable {
  private static final org.okiproject.okifuncapi.utility.UtilityException UNIMPLEMENTED =
    new org.okiproject.okifuncapi.utility.UtilityException(
      org.okiproject.okifuncapi.utility.UtilityException.UNIMPLEMENTED);

  /**
   * Method getDefaultUtilityFactory
   *
   *
   * @return org.okiproject.okifuncapi.utility.UtilityFactory
   *
   * @throws Exception
   *
   */
  public static org.okiproject.okifuncapi.utility.UtilityFactory getDefaultUtilityFactory()
  throws Exception {
    java.util.Map properties = getPropertiesFromPRB();

    return getUtilityFactory(properties);
  }

  /**
   * Method getUtilityFactory
   *
   *
   * @param props
   *
   * @return org.okiproject.okifuncapi.utility.UtilityFactory
   *
   * @throws Exception
   *
   */
  public static org.okiproject.okifuncapi.utility.UtilityFactory getUtilityFactory(
          java.util.Map props)
  throws Exception {
    java.util.Map properties = props;

    if (null == properties) {
      properties = getPropertiesFromPRB();
    }

    if (null != properties) {
      String factoryClassName = properties.getProperty("UtilityFactory");

      if (null != factoryClassName) {
        Class                                            factoryClass =
          Class.forName(factoryClassName);
        org.okiproject.okifuncapi.utility.UtilityFactory factory      =
          (org.okiproject.okifuncapi.utility.UtilityFactory) factoryClass.newInstance();

        factory.setProperties(properties);

        return Factory;
      }
    }

    throw new org.okiproject.okifuncapi.utility.UtilityException(
      org.okiproject.okifuncapi.utility.UtilityException.DEFAULTUTILITYFACTORYDIDNOTLOAD);
  }

  private java.util.Map properties = null;

  protected java.util.Map getProperties() {
    return this.properties;
  }

  protected void setProperties(java.util.Map properties) {
    this.properties = properties;
  }

  protected static java.util.Properties getPropertiesFromPRB()
  throws Exception {
    java.util.PropertyResourceBundle prb =
      (java.util.PropertyResourceBundle) java.util.ResourceBundle.getBundle(
        "UtilityFactory");

    if (null != prb) {
      java.util.Properties  properties = new java.util.Properties();
      java.util.Enumeration keys       = prb.getKeys();

      while (keys.hasMoreElements()) {
        String key = (String) keys.nextElement();

        properties.setProperty(key, (String) prb.handleGetObject(key));
      }

      return properties;
    }

    throw new org.okiproject.okifuncapi.utility.UtilityException(
      org.okiproject.okifuncapi.utility.UtilityException.UTILITYFACTORYPROPERTIESDIDNOTLOAD);
  }

}


/*--- Formatted in OKI Style on Fri, Feb 8, '02 ---*/


/*------ Formatted by Jindent 3.24 Basic 1.0 --- http://www.jindent.de ------*/
