package org.okiproject.serviceapi.authentication;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/authentication/Factory.java,v $
 */
/**
<p>
The Authentication API does not contain information that is expected
to be part of the implementation. There may be additional
implementation information that will need to be exposed in
this API.

 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/19 15:57:03 $
*/
public interface Factory
extends org.okiproject.serviceapi.common.Factory {

  /*
          Returns an Agent that may or may not be anonymous
  */

  org.okiproject.serviceapi.common.Agent getAgent()
  throws Throwable;

  /*
          Returns the types of Authentication that are available
          to the current implementation
  */

  String[] getAuthenTypes()
  throws Exception;

  /*
          Returns the types of Authentication that this
          agent currently has
  */

  /**
   * Method getDefaultAuthenType
   *
   *
   * @return String
   *
   * @throws Exception
   *
   */
  String getDefaultAuthenType()
  throws Exception;

  /**
   * Method setDefaultAuthenType
   *
   *
   * @param authenType
   *
   * @throws Exception
   *
   */
  void setDefaultAuthenType(String authenType)
  throws Exception;

  /**
   * Method getAuthenTypes
   *
   *
   * @param agent
   *
   * @return String[]
   *
   * @throws Exception
   *
   */
  String[] getAuthenTypes(org.okiproject.serviceapi.common.Agent agent)
  throws Exception;

  /**
   * Method isAuthenticated
   *
   *
   * @param agent
   *
   * @return Boolean
   *
   * @throws Exception
   *
   */
  Boolean isAuthenticated(org.okiproject.serviceapi.common.Agent agent,
    String authenType)
  throws Exception;

  /**
   * Method isAuthenticated for default authenType
   *
   *
   * @param agent
   *
   * @return Boolean
   *
   * @throws Exception
   *
   */
  Boolean isAuthenticated(org.okiproject.serviceapi.common.Agent agent)
  throws Exception;

  /**
   * Method getAgent
   *
   *
   * @param agent
   * @param type
   *
   * @return org.okiproject.serviceapi.common.Agent
   *
   * @throws Throwable
   *
   */
  org.okiproject.serviceapi.common.Agent getAgent(
    org.okiproject.serviceapi.common.Agent agent, String type)
  throws Throwable;

  /**
   * Method destroyAuthen
   *
   *
   * @param agent
   *
   * @throws Exception
   *
   */
  void destroyAuthen(org.okiproject.serviceapi.common.Agent agent)
  throws Exception;

  /**
   * Method destroyAuthen
   *
   *
   * @param agent
   * @param type
   *
   * @throws Exception
   *
   */
  void destroyAuthen(org.okiproject.serviceapi.common.Agent agent,
                            String type)
  throws Exception;

  /**
   * Method destroyAuthen
   *
   *
   * @param agent
   * @param types
   *
   * @throws Exception
   *
   */
  void destroyAuthen(org.okiproject.serviceapi.common.Agent agent,
                            String[] types)
  throws Exception;

}
