package org.okiproject.serviceapi.logging;

/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/

/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/logging/LogSpecificationFactory.java,v $
 */

/**
</pre>

<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/03/07 22:23:24 $
*/

public class LogSpecificationFactory
implements java.io.Serializable {
  private java.util.Map                          properties = null;
  private org.okiproject.serviceapi.common.Agent agent;

  protected static final org.okiproject.serviceapi.logging.LogSpecificationException UNIMPLEMENTED =
    org.okiproject.serviceapi.logging.LogSpecificationException.UNIMPLEMENTED_EXCEPTION;

  /**
   * Method getDefaultLogSpecificationFactory
   *
   *
   *
   * @param agent
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.logging.LogSpecificationFactory getDefaultLogSpecificationFactory(
          final org.okiproject.serviceapi.common.Agent agent)
  throws Exception {
    java.util.Map properties = getPropertiesFromPRB();

    return getLogSpecificationFactory(agent, properties);
  }

  /**
   * Method getLogSpecificationFactory
   *
   *
   * @param agent
   * @param props
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.logging.LogSpecificationFactory getLogSpecificationFactory(
          org.okiproject.serviceapi.common.Agent agent, java.util.Map props)
  throws Exception {
    java.util.Map properties = props;

    if (null == properties) {
      properties = getPropertiesFromPRB();
    }

    if (null != properties) {
      String factoryClassName =
        (String) properties.get("LogSpecificationFactory");

      if (null != factoryClassName) {
        Class                                                     factoryClass =
          Class.forName(factoryClassName);
        org.okiproject.serviceapi.logging.LogSpecificationFactory factory =
          (org.okiproject.serviceapi.logging.LogSpecificationFactory) (factoryClass.newInstance());

        factory.setProperties(properties);
        factory.setAgent(agent);

        return factory;
      }
    }

    throw org.okiproject.serviceapi.logging.LogSpecificationException.DEFAULT_FACTORY_LOADING_EXCEPTION;
  }

  protected static java.util.Properties getPropertiesFromPRB()
  throws Exception {
    java.util.PropertyResourceBundle prb =
      (java.util.PropertyResourceBundle) java.util.ResourceBundle.getBundle(
        "LogSpecificationFactory");

    if (null != prb) {
      java.util.Properties  properties = new java.util.Properties();
      java.util.Enumeration keys       = prb.getKeys();

      while (keys.hasMoreElements()) {
        String key = (String) keys.nextElement();

        properties.setProperty(key, (String) prb.handleGetObject(key));
      }

      return properties;
    }

    throw org.okiproject.serviceapi.logging.LogSpecificationException.PROPERTIES_LOADING_EXCEPTION;
  }

  /**
   * @return Properties.
   */
  public java.util.Map getProperties() {
    return this.properties;
  }

  /**
   * set Properties.
   */
  protected void setProperties(java.util.Map properties) {
    this.properties = properties;
  }

  protected void setAgent(org.okiproject.serviceapi.common.Agent agent) {
    this.agent = agent;
  }

  protected org.okiproject.serviceapi.common.Agent getAgent() {
    return this.agent;
  }

}
