package org.okiproject.serviceapi.rules;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/rules/Predicate.java,v $ 
 */
/**
<pre>
 *  @see org.okiproject.serviceapi.rules.Predicates
 *  @see org.okiproject.serviceapi.rules.PredicateType
 *  @see org.okiproject.serviceapi.rules.RulesFactory
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:53 $
*/
public interface Predicate
extends java.io.Serializable {

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  Object getId();

  /**
   * Method getPredicateType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.PredicateType getPredicateType();

  /**
   * Method getHasChild
   *
   *
   * @return
   *
   */
  Boolean getHasChild();

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  java.util.Properties getProperties();

  /**
   * Method setId
   *
   *
   * @param id
   *
   */
  void setId(Object id);

  /**
   * Method setPredicateType
   *
   *
   * @param predicateType
   *
   */
  void setPredicateType(
    org.okiproject.serviceapi.rules.PredicateType predicateType);

  /**
   * Deletes an existing predicate in the Roles DB.
   */
  void delete()
  throws Exception;

  /**
   * Determines if this Predicate has a matching Predicate in the Rules DB.
   *
   * @return true indicates Predicate is in the Rules DB as are its properties.
   * @return false        indicates Rules DB hasn't been queried or Predicate is not in the Rules DB.
   */
  Boolean isFoundInRules()
  throws Exception;

  /**
   * Refreshes properties from a changing Rules DB.
   */
  void refresh()
  throws Exception;

  /**
   * Updates one or more fields in an existing predicate in the Rules DB.
   */
  void update(org.okiproject.serviceapi.rules.PredicateType newPredicateType)
  throws Exception;

  /**
   * Adds a parent-child relationship between two existing predicates
   * in the Rules DB.
   */
  void addLink(org.okiproject.serviceapi.rules.Predicate parent)
  throws Exception;

  /**
   * Deletes a parent-child relationship between two existing predicates
   * in the Rules DB.
   */
  void deleteLink()
  throws Exception;

  /**
   * For an existing predicate, moves the parent link from one existing
   * predicate to another.
   */
  void moveLink(org.okiproject.serviceapi.rules.Predicate oldParent,
                org.okiproject.serviceapi.rules.Predicate newParent)
  throws Exception;

  /**
   * For an existing predicate, determines if the predicate is the child a
   * given parent
   */

  //Boolean isChildOf( org.okiproject.serviceapi.rules.Predicate parent ) throws Exception ;

  /**
   * For an existing predicate, get its descendents
   */
  //org.okiproject.serviceapi.rules.Predicates getDescendents() throws Exception ;

}
