package org.okiproject.serviceapi.rules;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/rules/RulesException.java,v $
 */
/**
 *
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.5 $ / $Date: 2002/02/18 15:45:25 $
*/

public class RulesException
extends org.okiproject.serviceapi.common.FactoryException {
  public static final String QUERYRULEFAILED                    =
    "Query rule failed ";
  public static final String CREATERULEFAILED                   =
    "Create rule failed ";
  public static final String DELETERULEFAILED                   =
    "Delete rule failed ";
  public static final String UPDATERULEFAILED                   =
    "Update rule failed ";
  public static final String RULEENUMERATIONFAILED              =
    "Enumeration of rules failed ";
  public static final String RULEFIELDDOESNOTEXIST              =
    "Rule field does not exist ";

  public static final String VERBIDALREADYEXISTS                =
    "Verb already exists ";
  public static final String INVALIDDATABASE                    =
    "Invalid database ";
  public static final String INVALIDVERB                        =
    "Invalid verb ";
  public static final String VERBNOTFOUNDINRULES                =
    "Verb not found in Rules ";
  public static final String VERBTYPENOTFOUNDINRULES            =
    "Verb type not found in Rules ";
  public static final String VERBENUMERATIONFAILED              =
    "Enumeration of verbs failed ";

  public static final String INVALIDSUBJECTKEY                  =
    "Invalid subject key ";
  public static final String SUBJECTNOTFOUNDINRULES             =
    "Subject not found in Rules ";
  public static final String SUBJECTTYPENOTFOUNDINRULES         =
    "Subject type not found in Rules ";
  public static final String SUBJECTSENUMERATIONFAILED          =
    "Enumeration of subjects failed ";

  public static final String INVALIDPREDICATE                   =
    "Invalid predicate ";
  public static final String PREDICATENOTFOUNDINRULES           =
    "Predicate not found in Rules ";
  public static final String PREDICATECODENOTFOUNDINRULES       =
    "Predicate code not found in Rules ";
  public static final String PREDICATETYPENOTFOUNDINRULES       =
    "Predicate type not found in Rules ";
  public static final String PREDICATEENUMERATIONFAILED         =
    "Enumeration of predicates failed ";

  /**
   * Constructor RulesException
   *
   *
   * @param message
   *
   */
  public RulesException(String message) {
    super(message);
  }

}
