package org.okiproject.serviceapi.rules;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/rules/Subject.java,v $ 
 */
/**
<pre>
 *  @see org.okiproject.serviceapi.rules.Subjects
 *  @see org.okiproject.serviceapi.rules.SubjectType
 *  @see org.okiproject.serviceapi.rules.RulesFactory
<p> 
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:54 $
*/
public interface Subject
extends java.io.Serializable {

  /**
   * Method getKey
   *
   *
   * @return
   *
   */
  Object getKey();

  /**
   * Method getName
   *
   *
   * @return
   *
   */
  String getName();

  /**
   * Method getSubjectType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.SubjectType getSubjectType();

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  java.util.Properties getProperties();

  /**
   * Method setKey
   *
   *
   * @param key
   *
   */
  void setKey(Object key);

  /**
   * Determines if this Subject has a matching Subject in the Rules DB.
   *
   * @return true  indicates Subject is in the Rules DB as are its properties.
   * @return false indicates Rules DB hasn't been queried or Subject is not in the Rules DB.
   */
  Boolean isFoundInRules()
  throws Exception;

  /**
   * Refresh properties from a changing Rules DB.
   */
  void refresh()
  throws Exception;

}
