package org.okiproject.serviceapi.rules;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/rules/Verb.java,v $ 
 */
/**
<pre>
 *  @see org.okiproject.serviceapi.rules.Verbs
 *  @see org.okiproject.serviceapi.rules.VerbType
 *  @see org.okiproject.serviceapi.rules.RulesFactory
<p> 
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:54 $
*/
public interface Verb
extends java.io.Serializable {

  /**
   * Method getDescription
   *
   *
   * @return
   *
   */
  String getDescription();

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  Object getId();

  /**
   * Method getModifiedBy
   *
   *
   * @return
   *
   */
  String getModifiedBy();

  /**
   * Method getModifiedDate
   *
   *
   * @return
   *
   */
  java.sql.Timestamp getModifiedDate();

  /**
   * Method getName
   *
   *
   * @return
   *
   */
  String getName();

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  java.util.Properties getProperties();

  /**
   * Method getVerbType
   *
   *
   * @return
   *
   */
  org.okiproject.serviceapi.rules.VerbType getVerbType();

  /**
   * Method setId
   *
   *
   * @param id
   *
   */
  void setId(Object id);

  /**
   * Method setName
   *
   *
   * @param name
   *
   */
  void setName(String name);

  /**
   * Method setVerbType
   *
   *
   * @param verbType
   *
   * @throws Exception
   *
   */
  void setVerbType(org.okiproject.serviceapi.rules.VerbType verbType)
  throws Exception;

  /**
   * Deletes an existing Verb in the Rules DB.
   */
  void delete()
  throws Exception;

  /**
   * Determines if this Verb has a matching Verb in the Rules DB.
   *
   * @return true indicates Verb is in the Rules DB as are its properties.
   * @return false indicates Rules DB hasn't been queried or Verb is not in the Rules DB.
   */
  Boolean isFoundInRules()
  throws Exception;

  /**
   * Refreshs properties from a changing Rules DB.
   */
  void refresh()
  throws Exception;

  /**
   * Updates one or more fields in an existing Verb in the Rules DB.
   * @see rules.VerbType
   */
  void update(String newName, String newDescription,
              org.okiproject.serviceapi.rules.VerbType newVerbType)
  throws Exception;

}
