package org.okiproject.serviceapi.usermessage;



import org.okiproject.serviceapi.common.*;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/usermessage/UserMsgClient.java,v $ 
 */
/**
<p>
Purpose: Abstracts a User Messaging Service subscriber.
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:16:18 $
*/
public interface UserMsgClient {

  /**
   * Method subscribe
   *
   *
   * @param me
   * @param topic
   *
   */
  public void subscribe(final Agent me, final String topic);

  /**
   * Method unsubscribe
   *
   *
   * @param me
   * @param topic
   *
   */
  public void unsubscribe(final Agent me, final String topic);

  /**
   * Method send
   *
   *
   * @param me
   * @param you
   * @param topic
   * @param msg
   *
   */
  public void send(final Agent me, final Agent you, final String topic,
                   final UserMessage msg);

  /**
   * Method receive
   *
   *
   * @param me
   * @param you
   * @param topic
   * @param msg
   *
   */
  public void receive(final Agent me, final Agent you, final String topic,
                      final UserMessage msg);
}
