package org.okiproject.serviceapi.usermessage;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceapi/usermessage/UserMsgFactory.java,v $ 
 */
/**
</pre>

<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/02/16 06:16:18 $
*/

public class UserMsgFactory
implements java.io.Serializable {

	static final String USERMSG_FACTORY_NAME = "UserMsgFactory";
  protected static final org.okiproject.serviceapi.usermessage.UserMsgException UNIMPLEMENTED =
    org.okiproject.serviceapi.usermessage.UserMsgException.UNIMPLEMENTED_EXCEPTION;

  private java.util.Map properties;
	private org.okiproject.serviceapi.common.Agent agent;


  /**
   * Method getDefaultUserMsgFactory
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.usermessage.UserMsgFactory getDefaultUserMsgFactory( final org.okiproject.serviceapi.common.Agent a,  
java.util.Properties props)               
  throws Exception {

		java.util.Properties p = props;
		if ( p == null ) {
			 p = getPropertiesFromPRB();
		}
		if ( p == null ) {
				throw org.okiproject.serviceapi.usermessage.UserMsgException.PROPERTIES_LOADING_EXCEPTION;
		}

    return getUserMsgFactory(a, p);
  }

  /**
   * Method getUserMsgFactory
   *
   *
   *
   * @param agent
   * @param props
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.usermessage.UserMsgFactory getUserMsgFactory( final org.okiproject.serviceapi.common.Agent agent, 
          java.util.Map props)
  throws Exception {
    java.util.Map properties = props;

/*
    if (null == properties) {
      properties = getPropertiesFromPRB();
    }
*/

    if (null != properties) {
      String factoryClassName = (String) properties.get(USERMSG_FACTORY_NAME);

      if (null != factoryClassName) {
        Class                                       factoryClass =
          Class.forName(factoryClassName);
        org.okiproject.serviceapi.usermessage.UserMsgFactory factory      =
          (org.okiproject.serviceapi.usermessage.UserMsgFactory) (factoryClass.newInstance());

        factory.setProperties(properties);
        factory.setAgent(agent);

        return factory;
      }
    }

    throw org.okiproject.serviceapi.usermessage.UserMsgException.DEFAULT_FACTORY_LOADING_EXCEPTION;
  }

  protected static java.util.Properties getPropertiesFromPRB()
  throws Exception {
    java.util.PropertyResourceBundle prb =
      (java.util.PropertyResourceBundle) java.util.ResourceBundle.getBundle(
       USERMSG_FACTORY_NAME );

    if (null != prb) {
      java.util.Properties  properties = new java.util.Properties();
      java.util.Enumeration keys       = prb.getKeys();

      while (keys.hasMoreElements()) {
        String key = (String) keys.nextElement();

        properties.setProperty(key, (String) prb.handleGetObject(key));
      }

      return properties;
    }

    throw org.okiproject.serviceapi.usermessage.UserMsgException.PROPERTIES_LOADING_EXCEPTION;
  }


  /**
   * @return Properties.
   */
  public java.util.Map getProperties() {
    return this.properties;
  }

  /**
   * set Properties.
   */
  protected void setProperties(java.util.Map properties) {
    this.properties = properties;
  }

	protected void setAgent(org.okiproject.serviceapi.common.Agent agent) {    
			this.agent = agent;                                                      
	}                                                                          

}
