package edu.mit.is.service.authentication.impl.authenkrb4 ;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/authen/Authenticate.java,v $
 */
/**
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.1 $ / $Date: 2002/03/06 22:01:24 $
*/
public class Authenticate
{
	private static String crealm = "ATHENA.MIT.EDU" ;
	private static String srealm = "ATHENA.MIT.EDU" ;
	private static String kdc = "KERBEROS.MIT.EDU" ;

	private static String sinstFrom( String alias )
	throws Exception
	{
		java.net.InetAddress aliasAddr
		= java.net.InetAddress.getByName( alias ) ;
		java.net.InetAddress realAddr
		= java.net.InetAddress.getByName( aliasAddr.getHostAddress() ) ;
		String realHost = realAddr.getHostName().toLowerCase() ;
		int index = realHost.indexOf( "." ) ;
		if( -1 != index )
		{
			realHost = realHost.substring( 0 , index ) ;
		}
		return realHost ;
	}

	public static krb4.lib.Krb4Creds getUserCredentials
		( String clientName
		, String clientInst
		, char[] clientPassWord
		)
		throws Throwable
	{
		byte[] key = krb4.lib.crypto.des.string_to_key_bytes( new String( clientPassWord ) ) ;

		krb4.lib.Krb4ASReq as_req
			= new krb4.lib.Krb4ASReq
				( clientName
				, clientInst
				, crealm
				, srealm
				) ;
		as_req.send( kdc ) ;
		krb4.lib.Krb4ASRep as_rep = as_req.getKrb4ASRep() ;
		return as_rep.getCreds( key ) ;
	}

	public static byte[] getServiceTicket
		( krb4.lib.Krb4Creds clientCredentials
		, String service
		, String host
		, String clientName
		, String clientInst
		)
	throws Throwable
	{
		if( null != clientCredentials )
		{
			krb4.lib.Krb4TGSReq tgs_req
				= new krb4.lib.Krb4TGSReq
					( clientCredentials
					, clientName
					, clientInst
					, crealm
					, service
					, sinstFrom( host )
					, srealm
					);
			tgs_req.send( kdc ) ;
			krb4.lib.Krb4TGSRep tgs_rep = tgs_req.getKrb4TGSRep() ;
			krb4.lib.Krb4Creds creds = tgs_rep.getCreds( clientCredentials ) ;
			krb4.lib.Krb4APReq ap_req
				= new krb4.lib.Krb4APReq
					( creds
					, clientName
					, clientInst
					, crealm
					, false
					) ;

			return ap_req.encode() ;
		}
		return null ;
	}

	public static String isValidClient
		( byte[] clientTicket
		, byte[] clientAddress
		, byte[] srvtab
		)
		throws Throwable
	{
		krb4.lib.Krb4Encode ref = new krb4.lib.Krb4Encode( srvtab );
		String service = ref.getString();
		String instance = ref.getString();
		String realm = ref.getString();
		byte keyVersion = ref.getByte();
		byte[] servKey = ref.getBytes(8);
		krb4.lib.Krb4APReq ap_req = new krb4.lib.Krb4APReq( clientTicket ) ;
		ap_req.authenticate
			( servKey
			, service
			, instance
			, realm
			, clientAddress
			) ;

		return new String( ap_req.getSessionKey() ) ;
	}

}