package org.okiproject.serviceimpl.mit.rmissl;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/rmissl/Client.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.8 $ / $Date: 2002/02/16 17:11:50 $
*/
public class Client
implements org.okiproject.serviceapi.romi.Client,
           org.okiproject.serviceimpl.mit.rmissl.Remote {
  private String host = null;

  /**
   * Method getHost
   *
   *
   * @return String
   *
   */
  public String getHost() {
    return this.host;
  }

  protected void setHost(String host) {
    this.host = host;
  }

  private Integer port = null;

  /**
   * Method getPort
   *
   *
   * @return Integer
   *
   */
  public Integer getPort() {
    return this.port;
  }

  protected void setPort(Integer port) {
    this.port = port;
  }

  private String service = null;

  /**
   * Method getService
   *
   *
   * @return String
   *
   */
  public String getService() {
    return this.service;
  }

  protected void setService(String service) {
    this.service = service;
  }

  private String server = null;

  /**
   * Method getServer
   *
   *
   * @return String
   *
   */
  public String getServer() {
    return this.server;
  }

  protected void setServer(String server) {
    this.server = server;
  }

  private org.okiproject.serviceapi.common.Agent forAgent = null;

  /**
   * Method getForAgent
   *
   *
   * @return org.okiproject.serviceapi.common.Agent
   *
   */
  public org.okiproject.serviceapi.common.Agent getForAgent() {
    return this.forAgent;
  }

  protected void setForAgent(
          org.okiproject.serviceapi.common.Agent forAgent) {
    this.forAgent = forAgent;
  }

  private Object response = null;

  /**
   * Method getResponse
   *
   *
   * @return Object
   *
   */
  public Object getResponse() {
    return this.response;
  }

  protected void setResponse(Object response) {
    this.response = response;
  }

  private org.okiproject.serviceimpl.mit.rmissl.Remote remote = null;

  protected org.okiproject.serviceimpl.mit.rmissl.Remote getRemote() {
    return this.remote;
  }

  protected void setRemote(
          org.okiproject.serviceimpl.mit.rmissl.Remote remote) {
    this.remote = remote;
  }

  private Client() {}

  /**
   * Method create
   *
   *
   * @param host
   * @param port
   * @param service
   * @param server
   * @param forAgent
   *
   * @return org.okiproject.serviceapi.romi.Client
   *
   * @throws Throwable
   *
   */
  public static org.okiproject.serviceapi.romi.Client create(String host,
          Integer port, String service, String server,
          org.okiproject.serviceapi.common.Agent forAgent)
  throws Throwable {
    org.okiproject.serviceimpl.mit.rmissl.Client client =
      new org.okiproject.serviceimpl.mit.rmissl.Client();

    client.setHost(host);
    client.setPort(port);
    client.setService(service);
    client.setServer(server);
    client.setForAgent(forAgent);
    client.setup();

    return client;
  }

  /**
   * Method authenticate
   *
   *
   * @param ticket
   *
   * @return Boolean
   *
   * @throws Exception
   *
   */
  public Boolean authenticate(byte[] ticket)
  throws Exception {
    try {
      if (null != getRemote()) {
        return getRemote().authenticate(ticket);
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    return new Boolean(false);
  }

  /**
   * Method invoke
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return Object
   *
   * @throws Exception
   *
   */
  public Object invoke(java.io.Serializable object, String methodName,
                       Class[] argTypes, Object[] args)
  throws Exception {
    try {
      if (null != getRemote()) {
        Object resp = getRemote().invoke(object, methodName, argTypes, args);

        setResponse(resp);
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    if (getResponse() instanceof Exception) {
      throw (Exception) getResponse();
    }

    return getResponse();
  }

  /**
   * Method test
   *
   *
   * @return String
   *
   * @throws Exception
   *
   */
  public String test()
  throws Exception {
    if (null != getRemote()) {
      return getRemote().test();
    }

    return "Test failed.";
  }

  protected void setup()
  throws Throwable {
    setResponse(null);

    if (null == System.getSecurityManager()) {
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    }

    if (null == getRemote()) {
      org.okiproject.serviceimpl.mit.rmissl.Remote remote =
        (org.okiproject.serviceimpl.mit.rmissl.Remote) java.rmi.Naming.lookup(
          "//" + getHost() + ":" + getPort().toString() + "/" + getServer());

      setRemote(remote);

      if ((null != getForAgent())
              && (getForAgent()
                  instanceof org.okiproject.serviceimpl.mit.common.Person)) {
        org.okiproject.serviceimpl.mit.common.Person person       =
          (org.okiproject.serviceimpl.mit.common.Person) getForAgent();
        krb4.lib.Krb4Creds                           creds        =
          (krb4.lib.Krb4Creds) person.getProperty(
            org.okiproject.serviceimpl.mit.common.Person.CREDENTIALS);
        String                                       kerberosName =
          (String) person.getProperty(
            org.okiproject.serviceimpl.mit.common.Person.KERBEROS_NAME);

        if (null != creds) {
          byte[] ticket =
            org.okiproject.serviceimpl.mit.krb4.Authenticate.getServiceTicket(
              creds, getService(), getHost(), kerberosName, "");

          authenticate(ticket);
        }
      }
    }
  }

}
