package org.okiproject.serviceimpl.mit.rmissl;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/rmissl/ClientSocketFactory.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 05:02:54 $
*/
public class ClientSocketFactory
implements java.rmi.server.RMIClientSocketFactory, java.io.Serializable {
  private static final int                        SOCKET_TIMEOUT = 10000;
  private static javax.net.SocketFactory          sslFactory     = null;
  private static java.rmi.server.RMISocketFactory rmiFactory     = null;

  /**
   * Method createSocket
   *
   *
   * @param host
   * @param port
   *
   * @return java.net.Socket
   *
   * @throws java.io.IOException
   *
   */
  public java.net.Socket createSocket(String host, int port)
  throws java.io.IOException {
    if (null == sslFactory) {
      sslFactory = javax.net.ssl.SSLSocketFactory.getDefault();
    }

    javax.net.ssl.SSLSocket s =
      (javax.net.ssl.SSLSocket) sslFactory.createSocket(host, port);

    s.setEnabledCipherSuites(s.getSupportedCipherSuites());
    s.setSoTimeout(SOCKET_TIMEOUT);

    return s;
  }

  /**
   * Method equals
   *
   *
   * @param that
   *
   * @return boolean
   *
   */
  public boolean equals(Object that) {
    return (that != null) && (that.getClass() == this.getClass());
  }

}
