
// worry: probably don't want to require mit.krb4.Authenticate for this

package org.okiproject.serviceimpl.mit.rmissl;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/rmissl/Server.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.6 $ / $Date: 2002/02/16 05:02:54 $
*/
public class Server
extends java.rmi.activation.Activatable
implements org.okiproject.serviceimpl.mit.rmissl.Remote {
  protected String            service         = null;
  protected transient byte[]  srvtab          = null;
  protected transient boolean isAuthenticated = true;
  protected String            tag             = null;

  /**
   * Constructor Server
   *
   *
   * @param id
   * @param data
   *
   * @throws Exception
   *
   */
  public Server(java.rmi.activation.ActivationID id,
                java.rmi.MarshalledObject data)
  throws Exception {
    super(
      id, 0,
      (java.rmi.server.RMIClientSocketFactory) new org.okiproject.serviceimpl.mit.rmissl.ClientSocketFactory(),
      (java.rmi.server.RMIServerSocketFactory) new org.okiproject.serviceimpl.mit.rmissl.ServerSocketFactory());

    srvtab = (byte[]) data.get();

    if (null != srvtab) {
      isAuthenticated = false;
    }
  }

  /**
   * Method authenticate
   *
   *
   * @param ticket
   *
   * @return Boolean
   *
   */
  public Boolean authenticate(byte[] ticket) {
    try {
      org.okiproject.serviceimpl.mit.krb4.Authenticate authenticate  =
        new org.okiproject.serviceimpl.mit.krb4.Authenticate();
      byte[]                                           clientAddress =
        java.net.InetAddress.getByName(getClientHost()).getAddress();
      String                                           host          =
        java.net.InetAddress.getLocalHost().getHostName();

      this.tag = authenticate.isValidClient(ticket, clientAddress, srvtab);

      org.okiproject.serviceimpl.mit.util.ThreadContext.setProperty("Tag",
              this.tag);

      isAuthenticated = true;

      return new Boolean(true);
    }
    catch (Throwable ex) {}

    return new Boolean(false);
  }

  /**
   * Method invoke
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return Object
   *
   */
  public Object invoke(java.io.Serializable object, String methodName,
                       Class[] argTypes, Object[] args) {
    Object response = null;

    try {
      if (isAuthenticated) {
        java.lang.reflect.Method method = null;

        if (!(object instanceof java.lang.Class)) {
          method = object.getClass().getMethod(methodName, argTypes);
        }
        else {
          method = ((Class) object).getMethod(methodName, argTypes);
        }

        response = method.invoke(object, args);
      }
      else {
        response =
          new org.okiproject.serviceimpl.mit.rmissl.AuthenticateException();
      }
    }
    catch (Throwable ex) {
      response = ex;
    }

    return response;
  }

  /**
   * Method test
   *
   *
   * @return String
   *
   */
  public String test() {
    return "Test successful";
  }

}
