package org.okiproject.serviceimpl.mit.rmissl;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/rmissl/ServerFactory.java,v $ 
 */
/**
</pre>
         * @see org.okiproject.serviceapi.romi.ServerFactory
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.8 $ / $Date: 2002/02/16 17:11:50 $
*/
public class ServerFactory
extends org.okiproject.serviceapi.romi.ServerFactory {

  /**
   * Method setup
   *
   *
   * @param props
   *
   * @throws Exception
   *
   */
  public void setup(java.util.Properties props)
  throws Exception {
    java.io.FileInputStream in        =
      new java.io.FileInputStream((String) props.get("srvtab"));

    byte[]                  srvtab    = new byte[0];
    int                     length    = 0;
    int                     available = 0;

    while (0 != in.available()) {
      available = in.available();

      byte[] newsrvtab = new byte[length + available];

      System.arraycopy(srvtab, 0, newsrvtab, 0, length);
      in.read(newsrvtab, length, available);

      srvtab = newsrvtab;
      length += available;
    }

    in.close();

    if (null == System.getSecurityManager()) {
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    }

    java.util.Properties props2 = new java.util.Properties();

    props2.put(props.get("policyProp"), props.get("policy"));

    java.rmi.activation.ActivationGroupDesc.CommandEnvironment ace   = null;
    java.rmi.activation.ActivationGroupDesc                    group =
      new java.rmi.activation.ActivationGroupDesc(props2, ace);

    java.rmi.activation.ActivationGroupID                      agi   =
      java.rmi.activation.ActivationGroup.getSystem().registerGroup(group);

    java.rmi.activation.ActivationGroup.createGroup(agi, group, 0);

    java.rmi.MarshalledObject          data =
      new java.rmi.MarshalledObject(srvtab);
    java.rmi.activation.ActivationDesc desc =
      new java.rmi.activation.ActivationDesc((String) props.get("server"),
                                             (String) props.get("location"),
                                             data);

    java.rmi.Remote                    mri  =
      java.rmi.activation.Activatable.register(desc);

    java.rmi.Naming.rebind((String) props.get("server"), mri);

    System.out.println("Exported Server");
  }

}
