package org.okiproject.serviceimpl.mit.rmissl;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/rmissl/ServerSocketFactory.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.3 $ / $Date: 2002/02/16 05:02:55 $
*/
public class ServerSocketFactory
implements java.rmi.server.RMIServerSocketFactory, java.io.Serializable {
  private static final int                     ANONYMOUS_PORT = 0;
  private static final int                     MAX_PORTS      = 100;
  private static javax.net.ServerSocketFactory sslFactory     = null;

  /**
   * Method createServerSocket
   *
   *
   * @param port
   *
   * @return java.net.ServerSocket
   *
   * @throws java.io.IOException
   *
   */
  public java.net.ServerSocket createServerSocket(int port)
  throws java.io.IOException {
    int       ssport    = port;
    Exception exception = null;

    if (ANONYMOUS_PORT == ssport) {
      ssport = 8000;
    }

    if (null == sslFactory) {
      sslFactory = javax.net.ssl.SSLServerSocketFactory.getDefault();
    }

    javax.net.ssl.SSLServerSocket s = null;

    for (int i = 0; MAX_PORTS != i; i++) {
      try {
        s = (javax.net.ssl.SSLServerSocket) sslFactory.createServerSocket(
          ssport + i);

        s.setEnabledCipherSuites(s.getSupportedCipherSuites());

        exception = null;

        break;
      }
      catch (Exception ex) {
        exception = ex;
      }
    }

    if (null != exception) {
      throw new java.io.IOException(exception.toString());
    }

    return s;
  }

  /**
   * Method equals
   *
   *
   * @param that
   *
   * @return boolean
   *
   */
  public boolean equals(Object that) {
    return (that != null) && (that.getClass() == this.getClass());
  }

}
