package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Functions.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.6 $ / $Date: 2002/02/16 17:10:36 $
*/
public class Functions
implements org.okiproject.serviceapi.authorization.Functions, java.io.Serializable {
  protected org.okiproject.serviceapi.dbc.Rows                rows         =
    null;
  protected org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method hasMoreFunctions
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public boolean hasMoreFunctions()
  throws Exception {
    if (null != this.rows) {
      return this.rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method nextFunction
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function nextFunction()
  throws Exception {
    if (null != this.rows) {
      return getFunction(this.rows.getColumnNames(), this.rows.nextRow());

    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.FUNCTIONENUMERATIONFAILED);
  }

  /**
   * Method getFunctionsInCategory
   *
   *
   * @param rolesFactory
   * @param functionCategory
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Functions getFunctionsInCategory(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory)
  throws Exception {
    try {
      if (null != rolesFactory) {
        org.okiproject.serviceapi.dbc.Connection connection =
          rolesFactory.getConnection();
        org.okiproject.serviceapi.dbc.Table      table      =
          connection.executeQuery(
            getFunctionsInCategorySQL(functionCategory.getCategory()));

        if (null != table) {
          org.okiproject.serviceimpl.mit.roles.Functions functions =
            new org.okiproject.serviceimpl.mit.roles.Functions();

          functions.rolesFactory = rolesFactory;
          functions.rows         = table.getRows();

          return functions;
        }
        else {
          if (rolesFactory.isFunctionCategoryFoundInRoles(
                  functionCategory).booleanValue()) {
            return null;
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.FUNCTIONCATEGORYNOTFOUNDINROLES);
  }

  protected static org.okiproject.serviceapi.authorization.Functions getFunctions(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String sqlQuery)
  throws Exception {
    try {
      if (null != sqlQuery) {
        org.okiproject.serviceapi.dbc.Connection       connection =
          rolesFactory.getConnection();
        org.okiproject.serviceapi.dbc.Table            table      =
          connection.executeQuery(sqlQuery);
        org.okiproject.serviceimpl.mit.roles.Functions functions  =
          new org.okiproject.serviceimpl.mit.roles.Functions();

        functions.rolesFactory = rolesFactory;
        functions.rows         = table.getRows();

        return functions;
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.FUNCTIONENUMERATIONFAILED);
  }

  private static String getFunctionsInCategorySQL(String functionCategory) {
    String sql = "select";

    sql +=
      " function_id, function_name, function_description, function_category,";
    sql += " modified_by, modified_date, qualifier_type";
    sql += " from function";
    sql += " where function_category = '" + functionCategory + "'";

    return sql;
  }

  private org.okiproject.serviceapi.authorization.Function getFunction(
          String[] columnNames, Object[] row)
  throws Exception {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties = new java.util.Properties();

      for (int i = 0; columnNames.length != i; i++) {
        properties.put(columnNames[i], row[i]);
      }

      return (new org.okiproject.serviceimpl.mit.roles.Function(
        this.rolesFactory, properties));
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.FUNCTIONENUMERATIONFAILED);
  }

}
