package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/GrantPrivilege.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.4 $ / $Date: 2002/02/16 17:10:36 $
*/
public class GrantPrivilege
implements org.okiproject.serviceapi.authorization.GrantPrivilege {
  private String grantPrivilege = null;

  /**
   * Constructor GrantPrivilege
   *
   *
   * @param grantPrivilege
   *
   * @throws Exception
   *
   */
  public GrantPrivilege(String grantPrivilege)
  throws Exception {
    if ((org.okiproject.serviceapi.authorization.GrantPrivilege.NOTGRANTABLE.equals(grantPrivilege))
            || (org.okiproject.serviceapi.authorization.GrantPrivilege.GRANTABLE.equals(grantPrivilege))
            || (org.okiproject.serviceapi.authorization.GrantPrivilege.GRANTABLEFORGRANTING.equals(
              grantPrivilege))) {
      this.grantPrivilege = grantPrivilege;

      return;
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDGRANTPRIVILEGE);
  }

  /**
   * Method toString
   *
   *
   * @return
   *
   */
  public String toString() {
    return this.grantPrivilege;
  }

  /**
   * Method isGrantable
   *
   *
   * @return
   *
   */
  public boolean isGrantable() {
    return (!this.grantPrivilege.equals(
      org.okiproject.serviceapi.authorization.GrantPrivilege.NOTGRANTABLE));
  }

  /**
   * Method isGrantableForGranting
   *
   *
   * @return
   *
   */
  public boolean isGrantableForGranting() {
    return (this.grantPrivilege.equals(
      org.okiproject.serviceapi.authorization.GrantPrivilege.GRANTABLEFORGRANTING));
  }

}
