package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/People.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.8 $ / $Date: 2002/02/16 17:10:36 $
*/
public class People
implements org.okiproject.serviceapi.common.Agents, java.io.Serializable {
  protected org.okiproject.serviceapi.dbc.Rows                rows         =
    null;
  protected org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method hasMoreAgents
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public boolean hasMoreAgents()
  throws Exception {
    if (null != this.rows) {
      return rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method nextAgent
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.common.Agent nextAgent()
  throws Exception {
    if (null != this.rows) {
      return getPerson(this.rows.getColumnNames(), this.rows.nextRow());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.PEOPLEENUMERATIONFAILED);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param rolesFactory
   * @param function
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          Boolean isActiveNow)
  throws Exception {
    return getPeopleInternal(rolesFactory, function, null, isActiveNow, null,
                             null);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param rolesFactory
   * @param function
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return getPeopleInternal(rolesFactory, function, qualifier, isActiveNow,
                             null, null);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param rolesFactory
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return getPeopleInternal(rolesFactory, null, qualifier, isActiveNow,
                             null, null);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param rolesFactory
   * @param functionCategory
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          Boolean isActiveNow)
  throws Exception {
    return getPeopleInternal(rolesFactory, (Object) null, (String) null,
                             functionCategory.getCategory(), (Object) null,
                             (String) null, (String) null,
                             isActiveNow.booleanValue()
                             ? "Y"
                             : "N", (String) null, (String) null);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param rolesFactory
   * @param functionCategory
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return getPeopleInternal(rolesFactory, (Object) null, (String) null,
                             functionCategory.getCategory(), (Object) null,
                             qualifier.getCode(),
                             qualifier.getQualifierType().getType(),
                             isActiveNow.booleanValue()
                             ? "Y"
                             : "N", (String) null, (String) null);
  }

  /**
   * Method getPeopleInternal
   *
   *
   * @param rolesFactory
   * @param function
   * @param qualifier
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.common.Agents getPeopleInternal(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    String                                      functionCategory    =
      (null == function)
      ? null
      : ((null == function.getFunctionCategory())
         ? null
         : function.getFunctionCategory().getCategory());
    String                                      functionName        =
      (null == function)
      ? null
      : function.getName();
    Object                                      functionId          =
      (null == function)
      ? null
      : function.getId();
    String                                      qualifierType       =
      (null == qualifier)
      ? null
      : ((null == qualifier.getQualifierType())
         ? null
         : qualifier.getQualifierType().getType());
    String                                      qualifierCode       =
      (null == qualifier)
      ? null
      : qualifier.getCode();
    Object                                      qualifierId         =
      (null == qualifier)
      ? null
      : qualifier.getId();
    String                                      expandFunctionsStr  =
      (null == expandFunctions)
      ? null
      : (expandFunctions.booleanValue()
         ? "Y"
         : "N");
    String                                      expandQualifiersStr =
      (null == expandQualifiers)
      ? null
      : (expandQualifiers.booleanValue()
         ? "Y"
         : "N");
    String                                      isActiveNowStr      =
      (null == isActiveNow)
      ? null
      : (isActiveNow.booleanValue()
         ? "Y"
         : "N");
    org.okiproject.serviceimpl.mit.roles.People people              =
      getPeopleInternal(rolesFactory, functionId, functionName,
                        functionCategory, qualifierId, qualifierCode,
                        qualifierType, isActiveNowStr, expandFunctionsStr,
                        expandQualifiersStr);

    if (null == people.rows) {
      if (rolesFactory.isFunctionFoundInRoles(function).booleanValue()) {
        if (rolesFactory.isQualifierFoundInRoles(qualifier).booleanValue()) {
          return people;
        }

        throw new org.okiproject.serviceapi.authorization.RolesException(
          org.okiproject.serviceapi.authorization.RolesException.QUALIFIERNOTFOUNDINROLES);
      }

      throw new org.okiproject.serviceapi.authorization.RolesException(
        org.okiproject.serviceapi.authorization.RolesException.FUNCTIONNOTFOUNDINROLES);
    }

    return people;
  }

  private static org.okiproject.serviceimpl.mit.roles.People getPeopleInternal(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          Object functionId, String functionName, String functionCategory,
          Object qualifierId, String qualifierCode, String qualifierType,
          String isActiveNowStr, String expandFunctionsStr,
          String expandQualifiersStr)
  throws Exception {
    try {
      String sqlQuery = getPeopleSQL(rolesFactory, expandQualifiersStr,
                                     isActiveNowStr, functionCategory,
                                     functionName, functionId, qualifierType,
                                     qualifierCode, qualifierId);

      return getPeople(rolesFactory, sqlQuery);
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        new String(
          org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED
          + ex.getMessage()));
    }
  }

  protected static org.okiproject.serviceimpl.mit.roles.People getPeople(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String sqlQuery)
  throws Exception {
    try {
      if (null != sqlQuery) {
        org.okiproject.serviceapi.dbc.Connection connection =
          rolesFactory.getConnection();
        org.okiproject.serviceapi.dbc.Table      table      =
          connection.executeQuery(sqlQuery);

        if (null != table) {
          org.okiproject.serviceimpl.mit.roles.People people =
            new org.okiproject.serviceimpl.mit.roles.People();

          people.rolesFactory = rolesFactory;
          people.rows         = table.getRows();

          return people;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUERYAUTHORIZATIONFAILED);
  }

  /**
   * @param algorithm is "WHO_CAN_DO"
   * @param expandQualifiers is either "Y" or "N", default is "N"
   * @param isActiveNow is either "Y" or "N", default is "N"
   */
  private static String getPeopleSQL(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String expandQualifiers, String isActiveNow,
          String functionCategory, String functionName, Object functionId,
          String qualifierType, String qualifierCode, Object qualifierId)
  throws Exception {
    if (null != rolesFactory) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      Object[]                                 args       = new Object[11];

      args[0]  = "WHO_CAN_DO";
      args[1]  = (null == expandQualifiers)
                 ? ""
                 : expandQualifiers;
      args[2]  = (null == isActiveNow)
                 ? ""
                 : isActiveNow;
      args[3]  = "";
      args[4]  = (null == functionCategory)
                 ? ""
                 : functionCategory;
      args[5]  = (null == functionName)
                 ? ""
                 : functionName;
      args[6]  = (null == functionId)
                 ? ""
                 : functionId.toString();
      args[7]  = (null == qualifierType)
                 ? ""
                 : qualifierType;
      args[8]  = (null == qualifierCode)
                 ? ""
                 : qualifierCode;
      args[9]  = (null == qualifierId)
                 ? ""
                 : qualifierId.toString();
      args[10] = "";

      int[] columnTypes = new int[12];

      columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[11] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[12];

      dataTypes[0]  = java.sql.Types.VARCHAR;
      dataTypes[1]  = java.sql.Types.VARCHAR;
      dataTypes[2]  = java.sql.Types.VARCHAR;
      dataTypes[3]  = java.sql.Types.VARCHAR;
      dataTypes[4]  = java.sql.Types.VARCHAR;
      dataTypes[5]  = java.sql.Types.VARCHAR;
      dataTypes[6]  = java.sql.Types.VARCHAR;
      dataTypes[7]  = java.sql.Types.VARCHAR;
      dataTypes[8]  = java.sql.Types.VARCHAR;
      dataTypes[9]  = java.sql.Types.VARCHAR;
      dataTypes[10] = java.sql.Types.VARCHAR;
      dataTypes[11] = java.sql.Types.VARCHAR;

      org.okiproject.serviceapi.dbc.Table tab =
        connection.callProcedure("ROLESAPI_GET_SQL_AUTH1", args, columnTypes,
                                 dataTypes);

      if (null != tab) {
        org.okiproject.serviceapi.dbc.Rows rows = tab.getRows();

        if (rows.hasMoreRows()) {
          Object[] row = rows.nextRow();
          String   sql = (String) row[0];

          return sql;
        }
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.PEOPLEENUMERATIONFAILED);
  }

  private org.okiproject.serviceapi.common.Person getPerson(
          String[] columnNames, Object[] row)
  throws Exception {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties = new java.util.Properties();

      for (int i = 0; columnNames.length != i; i++) {
        properties.put(columnNames[i], row[i]);
      }

      return new org.okiproject.serviceimpl.mit.roles.Person(rolesFactory,
              properties);
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.PEOPLEENUMERATIONFAILED);
  }

}
