package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/Qualifiers.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.5 $ / $Date: 2002/02/16 17:10:37 $
*/
public class Qualifiers
implements org.okiproject.serviceapi.authorization.Qualifiers, java.io.Serializable {
  protected org.okiproject.serviceapi.dbc.Rows                rows         =
    null;
  protected org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory =
    null;

  /**
   * Method hasMoreQualifiers
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public boolean hasMoreQualifiers()
  throws Exception {
    if (null != this.rows) {
      return rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method nextQualifier
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier nextQualifier()
  throws Exception {
    if (null != this.rows) {
      return getQualifier(this.rows.getColumnNames(), this.rows.nextRow());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUALIFIERENUMERATIONFAILED);
  }

  /**
   * Method getQualifierChildren
   *
   *
   * @param rolesFactory
   * @param qualifier
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static org.okiproject.serviceapi.authorization.Qualifiers getQualifierChildren(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    if ((null != rolesFactory) && (null != qualifier)) {
      org.okiproject.serviceapi.dbc.Connection connection =
        rolesFactory.getConnection();
      org.okiproject.serviceapi.dbc.Table      table      = connection.executeQuery(
        new String(
          "select" + " q.qualifier_id, q.qualifier_code, q.qualifier_name,"
          + " q.qualifier_type, q.has_child"
          + " from qualifier q0, qualifier_child qc, qualifier q" + " where "
          + " q0.qualifier_type = '"
          + ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifier.getQualifierType()).getType()
          + "'" + " and q0.qualifier_code = '"
          + ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).getCode()
          + "'" + " and qc.parent_id = q0.qualifier_id"
          + " and q.qualifier_id = qc.child_id"
          + " order by q.qualifier_code"));

      if (null != table) {
        org.okiproject.serviceimpl.mit.roles.Qualifiers qualifiers =
          new org.okiproject.serviceimpl.mit.roles.Qualifiers();

        qualifiers.rolesFactory = rolesFactory;
        qualifiers.rows         = table.getRows();

        return qualifiers;
      }
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.INVALIDQUALIFIER);
  }

  protected static org.okiproject.serviceapi.authorization.Qualifiers getQualifiers(
          org.okiproject.serviceimpl.mit.roles.RolesFactory rolesFactory,
          String sqlQuery)
  throws Exception {
    try {
      if (null != sqlQuery) {
        org.okiproject.serviceapi.dbc.Connection        connection =
          rolesFactory.getConnection();
        org.okiproject.serviceapi.dbc.Table             table      =
          connection.executeQuery(sqlQuery);
        org.okiproject.serviceimpl.mit.roles.Qualifiers qualifiers =
          new org.okiproject.serviceimpl.mit.roles.Qualifiers();

        qualifiers.rolesFactory = rolesFactory;
        qualifiers.rows         = table.getRows();

        return qualifiers;
      }
    }
    catch (Exception ex) {
      throw new org.okiproject.serviceapi.authorization.RolesException(
        ex.getMessage());
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUALIFIERENUMERATIONFAILED);
  }

  private org.okiproject.serviceapi.authorization.Qualifier getQualifier(
          String[] columnNames, Object[] row)
  throws Exception {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties = new java.util.Properties();

      for (int i = 0; columnNames.length != i; i++) {
        properties.put(columnNames[i], row[i]);
      }

      return new org.okiproject.serviceimpl.mit.roles.Qualifier(
        this.rolesFactory, properties);
    }

    throw new org.okiproject.serviceapi.authorization.RolesException(
      org.okiproject.serviceapi.authorization.RolesException.QUALIFIERENUMERATIONFAILED);
  }
}
