package org.okiproject.serviceimpl.mit.roles;
/*

   Copyright (c) 2001 Massachusetts Institute of Technology

   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.

*/
/*
 * $Source: /cvs/oki/org/okiproject/serviceimpl/mit/roles/RolesFactory.java,v $ 
 */
/**
<p>
 * <p>
 * See the {@link org.okiproject.License License}.
 *
 * @version $Revision: 1.19 $ / $Date: 2002/02/16 17:10:37 $
*/
public class RolesFactory
extends org.okiproject.serviceapi.authorization.RolesFactory {
  private static final String                      NODATE      = "        ";
  private static String                            STATUS_DATE =
    "STATUS_DATE";

  private static int                               count       = 0;

  private org.okiproject.serviceapi.dbc.SqlFactory sqlFactory  = null;

  /**
   * Method getSqlFactory
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.dbc.SqlFactory getSqlFactory() {
    return sqlFactory;
  }

  private org.okiproject.serviceapi.dbc.Connection connection = null;

  /**
   * Method getConnection
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.dbc.Connection getConnection()
  throws Exception {
    if (null == sqlFactory) {
      sqlFactory =
        org.okiproject.serviceapi.dbc.SqlFactory.getDefaultSqlFactory(
          getProperties());
    }

    if (null != sqlFactory) {
      connection = sqlFactory.newConnection(getProperties(),
                                            getServiceName());
    }

    return this.connection;
  }

  private org.okiproject.serviceapi.authorization.Person forUser = null;

  /**
   * Method getForUser
   *
   *
   * @return
   *
   */
  public org.okiproject.serviceapi.authorization.Person getForUser() {
    if (null == this.forUser) {
      if (null != getProperties()) {
        String kerberosName = (String) getProperties().get("ForUser");

        if (null != kerberosName) {
          this.forUser = new org.okiproject.serviceimpl.mit.roles.Person(this,
                  kerberosName, null, null, null, null, null, null, null,
                  null, null, null, null);
        }
      }
    }

    return this.forUser;
  }

  /**
   * Method createRolesDate
   *
   *
   * @param timestamp
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static String createRolesDate(java.sql.Timestamp timestamp)
  throws Exception {
    if (null != timestamp) {
      java.util.GregorianCalendar date = new java.util.GregorianCalendar();

      date.setTime((java.util.Date) timestamp);

      String rolesDate = "";
      int    year      = date.get(java.util.Calendar.YEAR);
      int    day       = date.get(java.util.Calendar.DAY_OF_MONTH);
      int    month     = date.get(java.util.Calendar.MONTH) + 1;

      if (month < 10) {
        rolesDate += "0";
      }

      rolesDate += Integer.toString(month);

      if (day < 10) {
        rolesDate += "0";
      }

      rolesDate += Integer.toString(day) + Integer.toString(year);

      return rolesDate;
    }

    return NODATE;
  }

  /**
   * Method createSqlTimestamp
   *
   *
   * @param rolesDate
   *
   * @return
   *
   * @throws Exception
   *
   */
  public static java.sql.Timestamp createSqlTimestamp(String rolesDate)
  throws Exception {
    if (null != rolesDate) {
      int                         month =
        Integer.parseInt(rolesDate.substring(0, 2)) - 1;
      int                         day   =
        Integer.parseInt(rolesDate.substring(2, 4));
      int                         year  =
        Integer.parseInt(rolesDate.substring(4, 8));
      java.util.GregorianCalendar gc    =
        new java.util.GregorianCalendar(year, month, day);

      return new java.sql.Timestamp(gc.getTime().getTime());
    }

    return null;
  }

  /**
   * Method createAuthorization
   *
   *
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   * @param effectiveDate
   * @param expirationDate
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorization createAuthorization(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          Boolean doFunction, java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorization.create(this,
            person, function, qualifier, grant, doFunction, effectiveDate,
            expirationDate);
  }

  /**
   * Method createAuthorization
   *
   *
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorization createAuthorization(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          Boolean doFunction)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorization.create(this,
            person, function, qualifier, grant, doFunction);
  }

  /**
   * Method deleteAuthorization
   *
   *
   * @param authorization
   *
   * @throws Exception
   *
   */
  public void deleteAuthorization(
          org.okiproject.serviceapi.authorization.Authorization authorization)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Authorization) authorization).delete();
  }

  /**
   * Method updateAuthorization
   *
   *
   * @param authorization
   * @param person
   * @param function
   * @param qualifier
   * @param grant
   * @param doFunction
   * @param effectiveDate
   * @param expirationDate
   *
   * @throws Exception
   *
   */
  public void updateAuthorization(
          org.okiproject.serviceapi.authorization.Authorization authorization,
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          org.okiproject.serviceapi.authorization.GrantPrivilege grant,
          Boolean doFunction, java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Authorization) authorization).update(
      person, function, qualifier, grant, doFunction, effectiveDate,
      expirationDate);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param function
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.People.getWhoCanDo(this,
            function, qualifier, isActiveNow);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param function
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceapi.authorization.Function function,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.People.getWhoCanDo(this,
            function, isActiveNow);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param functionCategory
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.People.getWhoCanDo(this,
            functionCategory, isActiveNow);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param functionCategory
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.common.Agents getWhoCanDo(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.People.getWhoCanDo(this,
            functionCategory, qualifier, isActiveNow);
  }

  /* [chs 12/4/2001] This needs changes to the stored procedure to work.
          It is not clear if this should be implemented as it might
          return a large number of People. Jim Repa is considering this.
          public org.okiproject.serviceapi.common.Agents getWhoCanDo
                  ( org.okiproject.serviceapi.authorization.Qualifier qualifier
                  , Boolean isActiveNow
                  )
                  throws Exception
          {
                  return org.okiproject.serviceimpl.mit.roles.People.getWhoCanDo
                          ( this
                          , qualifier
                          , isActiveNow
                          ) ;
          }
  */

  /**
   * Method getAuthsForDoingFWithQ
   *
   *
   * @param function
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsForDoingFWithQ(
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsForDoingFWithQ(
      this, function, qualifier, isActiveNow);
  }

  /**
   * Method getAuthsForDoingFWithQ
   *
   *
   * @param functionCategory
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsForDoingFWithQ(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsForDoingFWithQ(
      this, functionCategory, qualifier, isActiveNow);
  }

  /**
   * Method getAuthsSimpleForm
   *
   *
   * @param person
   * @param function
   * @param qualifier
   * @param isActiveNow
   * @param expandFunctions
   * @param qualifiersOptions
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean qualifiersOptions)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsSimpleForm(
      this, person, function, qualifier, isActiveNow, expandFunctions,
      qualifiersOptions);
  }

  /**
   * Method getAuthsSimpleForm
   *
   *
   * @param person
   * @param functionCategory
   * @param qualifier
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsSimpleForm(
      this, person, functionCategory, qualifier, isActiveNow,
      expandFunctions, expandQualifiers);
  }

  /**
   * Method getAuthsSimpleForm
   *
   *
   * @param person
   * @param function
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsSimpleForm(
      this, person, function, isActiveNow, expandFunctions, expandQualifiers);
  }

  /**
   * Method getAuthsSimpleForm
   *
   *
   * @param person
   * @param functionCategory
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          Boolean isActiveNow, Boolean expandFunctions,
          Boolean expandQualifiers)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsSimpleForm(
      this, person, functionCategory, isActiveNow, expandFunctions,
      expandQualifiers);
  }

  /**
   * Method getAuthsSimpleForm
   *
   *
   * @param person
   * @param isActiveNow
   * @param expandFunctions
   * @param expandQualifiers
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Authorizations getAuthsSimpleForm(
          org.okiproject.serviceapi.authorization.Person person, Boolean isActiveNow,
          Boolean expandFunctions, Boolean expandQualifiers)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorizations.getAuthsSimpleForm(
      this, person, isActiveNow, expandFunctions, expandQualifiers);
  }

  /**
   * Method isAuthorized
   *
   *
   * @param person
   * @param function
   * @param qualifier
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isAuthorized(
          org.okiproject.serviceapi.authorization.Person person,
          org.okiproject.serviceapi.authorization.Function function,
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Authorization.isAuthorized(
      this, (org.okiproject.serviceimpl.mit.roles.Person) person,
      (org.okiproject.serviceimpl.mit.roles.Function) function,
      (org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier);
  }

  private String[]                                authorizationFieldNames = {
    "id" };    //TODO: populate this list

  private org.okiproject.serviceapi.authorization.Field[] authorizationFields     =
    null;

  /**
   * Method getCurrentAuthorizationFields
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Field[] getCurrentAuthorizationFields()
  throws Exception {
    if (null == authorizationFields) {
      authorizationFields =
        new org.okiproject.serviceapi.authorization.Field[authorizationFieldNames.length];

      for (int i = 0; authorizationFields.length != i; i++) {
        authorizationFields[i] = new org.okiproject.serviceapi.authorization.Field(
          authorizationFieldNames[i]);
      }
    }

    return authorizationFields;
  }

  private String[]                                personFieldNames = { "id" };    //TODO: populate this list

  private org.okiproject.serviceapi.authorization.Field[] personFields     = null;

  /**
   * Method getCurrentPersonFields
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Field[] getCurrentPersonFields()
  throws Exception {
    if (null == personFields) {
      personFields =
        new org.okiproject.serviceapi.authorization.Field[personFieldNames.length];

      for (int i = 0; personFields.length != i; i++) {
        personFields[i] =
          new org.okiproject.serviceapi.authorization.Field(personFieldNames[i]);
      }
    }

    return personFields;
  }

  /**
   * Method newPerson
   *
   *
   * @param key
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Person newPerson(Object key)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.Person(this,
            (String) key, null, null, null, null, null, null, null, null,
            null, null, null);
  }

  /**
   * Method isPersonFoundInRoles
   *
   *
   * @param person
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isPersonFoundInRoles(
          org.okiproject.serviceapi.authorization.Person person)
  throws Exception {
    return ((org.okiproject.serviceimpl.mit.roles.Person) person).isFoundInRoles();
  }

  /**
   * Method refreshPerson
   *
   *
   * @param person
   *
   * @throws Exception
   *
   */
  public void refreshPerson(org.okiproject.serviceapi.authorization.Person person)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Person) person).refresh();
  }

  private String[]                                functionFieldNames = {
    "id" };    //TODO: populate this list

  private org.okiproject.serviceapi.authorization.Field[] functionFields     = null;

  /**
   * Method getCurrentFunctionFields
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Field[] getCurrentFunctionFields()
  throws Exception {
    if (null == functionFields) {
      functionFields =
        new org.okiproject.serviceapi.authorization.Field[functionFieldNames.length];

      for (int i = 0; functionFields.length != i; i++) {
        functionFields[i] =
          new org.okiproject.serviceapi.authorization.Field(functionFieldNames[i]);
      }
    }

    return functionFields;
  }

  /**
   * Method newFunction
   *
   *
   * @param functionCategory
   * @param name
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function newFunction(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          String name)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.Function(this, name,
            (String) null, functionCategory,
            (org.okiproject.serviceapi.authorization.QualifierType) null);
  }

  /**
   * Method newFunction
   *
   *
   * @param functionCategoryString
   * @param name
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function newFunction(
          String functionCategoryString, String name)
  throws Exception {
    org.okiproject.serviceimpl.mit.roles.FunctionCategory functionCategory =
      new org.okiproject.serviceimpl.mit.roles.FunctionCategory(this,
        functionCategoryString, (String) null);

    return new org.okiproject.serviceimpl.mit.roles.Function(this, name,
            (String) null, functionCategory,
            (org.okiproject.serviceapi.authorization.QualifierType) null);
  }

  /**
   * Method newFunction
   *
   *
   * @param id
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function newFunction(Object id)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.Function(this, id,
            (String) null, (String) null,
            (org.okiproject.serviceapi.authorization.FunctionCategory) null,
            (org.okiproject.serviceapi.authorization.QualifierType) null);
  }

  /**
   * Method newFunction
   *
   *
   * @param id
   * @param functionCategory
   * @param name
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function newFunction(Object id,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          String name)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.Function(this, id, name,
            (String) null, functionCategory,
            (org.okiproject.serviceapi.authorization.QualifierType) null);
  }

  /**
   * Method newFunctionCategory
   *
   *
   * @param functionCategoryString
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.FunctionCategory newFunctionCategory(
          String functionCategoryString)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.FunctionCategory(this,
            functionCategoryString, (String) null);
  }

  /**
   * Method createFunction
   *
   *
   * @param name
   * @param description
   * @param functionCategory
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Function createFunction(String name,
          String description,
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory,
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Function.create(
      this, name, description,
      (org.okiproject.serviceimpl.mit.roles.FunctionCategory) functionCategory,
      (org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType);
  }

  /**
   * Method deleteFunction
   *
   *
   * @param function
   *
   * @throws Exception
   *
   */
  public void deleteFunction(
          org.okiproject.serviceapi.authorization.Function function)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Function) function).delete();
  }

  /**
   * Method isFunctionFoundInRoles
   *
   *
   * @param function
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFunctionFoundInRoles(
          org.okiproject.serviceapi.authorization.Function function)
  throws Exception {
    return ((org.okiproject.serviceimpl.mit.roles.Function) function).isFoundInRoles();
  }

  /**
   * Method refreshFunction
   *
   *
   * @param function
   *
   * @throws Exception
   *
   */
  public void refreshFunction(
          org.okiproject.serviceapi.authorization.Function function)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Function) function).refresh();
  }

  /**
   * Method updateFunction
   *
   *
   * @param function
   * @param newName
   * @param newDescription
   * @param newFunctionCategory
   * @param newQualifierType
   *
   * @throws Exception
   *
   */
  public void updateFunction(
          org.okiproject.serviceapi.authorization.Function function, String newName,
          String newDescription,
          org.okiproject.serviceapi.authorization.FunctionCategory newFunctionCategory,
          org.okiproject.serviceapi.authorization.QualifierType newQualifierType)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Function) function).update(newName,
            newDescription, newFunctionCategory, newQualifierType);
  }

  /**
   * Method isFunctionCategoryFoundInRoles
   *
   *
   * @param functionCategory
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isFunctionCategoryFoundInRoles(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory)
  throws Exception {
    return ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) functionCategory).isFoundInRoles();
  }

  /**
   * Method refreshFunctionCategory
   *
   *
   * @param functionCategory
   *
   * @throws Exception
   *
   */
  public void refreshFunctionCategory(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.FunctionCategory) functionCategory).refresh();
  }

  /**
   * Method getFunctionsInCategory
   *
   *
   * @param functionCategory
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Functions getFunctionsInCategory(
          org.okiproject.serviceapi.authorization.FunctionCategory functionCategory)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Functions.getFunctionsInCategory(
      this,
      (org.okiproject.serviceimpl.mit.roles.FunctionCategory) functionCategory);
  }

  private String[]                                qualifierFieldNames = {
    "id" };    //TODO: populate this list

  private org.okiproject.serviceapi.authorization.Field[] qualifierFields     = null;

  /**
   * Method getCurrentQualifierFields
   *
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Field[] getCurrentQualifierFields()
  throws Exception {
    if (null == qualifierFields) {
      qualifierFields =
        new org.okiproject.serviceapi.authorization.Field[qualifierFieldNames.length];

      for (int i = 0; qualifierFields.length != i; i++) {
        qualifierFields[i] =
          new org.okiproject.serviceapi.authorization.Field(qualifierFieldNames[i]);
      }
    }

    return qualifierFields;
  }

  /**
   * Method createQualifier
   *
   *
   * @param qualifierType
   * @param qualifierCode
   * @param description
   * @param parent
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier createQualifier(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType,
          String qualifierCode, String description,
          org.okiproject.serviceapi.authorization.Qualifier parent)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Qualifier.create(this,
            qualifierType, qualifierCode, description, parent);
  }

  /**
   * Method deleteQualifier
   *
   *
   * @param qualifier
   *
   * @throws Exception
   *
   */
  public void deleteQualifier(
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).delete();
  }

  /**
   * Method isQualifierFoundInRoles
   *
   *
   * @param qualifier
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isQualifierFoundInRoles(
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    return ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).isFoundInRoles();
  }

  /**
   * Method refreshQualifier
   *
   *
   * @param qualifier
   *
   * @throws Exception
   *
   */
  public void refreshQualifier(
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).refresh();
  }

  /**
   * Method updateQualifier
   *
   *
   * @param qualifier
   * @param newQualifierCode
   * @param newDescription
   *
   * @throws Exception
   *
   */
  public void updateQualifier(
          org.okiproject.serviceapi.authorization.Qualifier qualifier,
          String newQualifierCode, String newDescription)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.Qualifier) qualifier).update(
      newQualifierCode, newDescription);
  }

  /**
   * Method isQualifierTypeFoundInRoles
   *
   *
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public Boolean isQualifierTypeFoundInRoles(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    return ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType).isFoundInRoles();
  }

  /**
   * Method refreshQualifierType
   *
   *
   * @param qualifierType
   *
   * @throws Exception
   *
   */
  public void refreshQualifierType(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    ((org.okiproject.serviceimpl.mit.roles.QualifierType) qualifierType).refresh();
  }

  /**
   * Method getRootQualifier
   *
   *
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier getRootQualifier(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Qualifier.getRootQualifier(
      this, qualifierType);
  }

  /**
   * Method getQualifierChildren
   *
   *
   * @param qualifier
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifiers getQualifierChildren(
          org.okiproject.serviceapi.authorization.Qualifier qualifier)
  throws Exception {
    return org.okiproject.serviceimpl.mit.roles.Qualifiers.getQualifierChildren(
      this, qualifier);
  }

  /**
   * Method newQualifier
   *
   *
   * @param qualifierType
   * @param qualifierCode
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier newQualifier(
          org.okiproject.serviceapi.authorization.QualifierType qualifierType,
          String qualifierCode)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.Qualifier(this,
            qualifierCode, null, qualifierType);
  }

  /**
   * Method newQualifier
   *
   *
   * @param id
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier newQualifier(Object id)
  throws Exception {
    return new Qualifier(this, id, null, null, null);
  }

  /**
   * Method newQualifier
   *
   *
   * @param qualifierType
   * @param qualifierCode
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.Qualifier newQualifier(
          String qualifierType, String qualifierCode)
  throws Exception {
    org.okiproject.serviceimpl.mit.roles.QualifierType qt =
      new org.okiproject.serviceimpl.mit.roles.QualifierType(this,
        qualifierType, (String) null);

    return new org.okiproject.serviceimpl.mit.roles.Qualifier(this,
            qualifierCode, null, qt);
  }

  /**
   * Method newQualifierType
   *
   *
   * @param qualifierType
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.QualifierType newQualifierType(
          String qualifierType)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.QualifierType(this,
            qualifierType, (String) null);
  }

  /**
   * Method newGrantPrivilege
   *
   *
   * @param grantPrivilege
   *
   * @return
   *
   * @throws Exception
   *
   */
  public org.okiproject.serviceapi.authorization.GrantPrivilege newGrantPrivilege(
          String grantPrivilege)
  throws Exception {
    return new org.okiproject.serviceimpl.mit.roles.GrantPrivilege(
      grantPrivilege);
  }

}
